<?php
// デバック　被リンク抽出　2024/8/21
function RM_check_blog_links() {
    // 全ての公開済み投稿を取得
    $args = array(
        'post_type' => 'post',
        'post_status' => 'publish',
        'posts_per_page' => -1
    );
    $posts = get_posts($args);

    $results = array();

    foreach ($posts as $post) {
        $results[$post->ID] = array(
            'title' => $post->post_title,
            'url' => get_permalink($post->ID),
            'links' => array()
        );
    }

    foreach ($posts as $post) {
        // 投稿の内容を取得
        $content = $post->post_content;

        foreach ($results as $id => $data) {
            if ($post->ID == $id) {
                continue;
            }

            // 正確なURLが他の投稿に含まれているかどうかを正規表現で確認
            $pattern = preg_quote($data['url'], '/');
            if (preg_match('/\b' . $pattern . '\b/', $content)) {
                $results[$id]['links'][] = '<a href="' . get_permalink($post->ID) . '">' . $post->post_title . '</a>';
            }
        }
    }

    // 結果を出力形式にフォーマット
    $output = '<ul>';
    foreach ($results as $data) {
        $output .= '<li><a href="' . $data['url'] . '">' . $data['title'] . '</a><ul>';
        if (empty($data['links'])) {
            $output .= '<li>被リンク無し</li>';
        } else {
            foreach ($data['links'] as $link) {
                $output .= '<li>' . $link . '</li>';
            }
        }
        $output .= '</ul></li>';
    }
    $output .= '</ul>';

    return $output;
}
add_shortcode('RM-check_blog_links', 'RM_check_blog_links');
