<?php
// 動画ファイル件数抽出　2024/8/21
function ryoumou_trade_check_videos() {  // 関数名を変更
    // 全ての投稿を取得
    $args = array(
        'numberposts' => -1, // 全ての記事を取得
        'post_type' => 'post', // 投稿タイプ
    );
    
    $all_posts = get_posts($args);
    $output = '<ul>';
    
    foreach ($all_posts as $post) {
        // コンテンツを取得
        $content = $post->post_content;
        $youtube_count = 0;
        $tiktok_count = 0;
        $instagram_count = 0;
        
        // YouTube動画の検出 (重複を避けるためにユニークなURLをカウント)
        preg_match_all('/(youtube\\.com\\/embed\\/[a-zA-Z0-9_-]+|youtube\\.com\\/watch\\?v=[a-zA-Z0-9_-]+|youtu\\.be\\/[a-zA-Z0-9_-]+)/', $content, $youtube_matches);
        $youtube_count = count(array_unique($youtube_matches[0]));
        
        // TikTok動画の検出 (重複を避けるためにユニークなURLをカウント)
        preg_match_all('/(tiktok\\.com\\/@[a-zA-Z0-9_.-]+\\/video\\/[0-9]+)/', $content, $tiktok_matches);
        $tiktok_count = count(array_unique($tiktok_matches[0]));
        
        // Instagram動画の検出 (重複を避けるためにユニークなURLをカウント)
        preg_match_all('/(instagram\\.com\\/p\\/[a-zA-Z0-9_-]+)/', $content, $instagram_matches);
        $instagram_count = count(array_unique($instagram_matches[0]));
        
        // 記事のタイトルと動画の数を出力
        $output .= '<li>';
        $output .= '<strong>' . esc_html($post->post_title) . '</strong><br>';  // 記事タイトルと改行
        $output .= '＞＞ YouTube: ' . $youtube_count . ', TikTok: ' . $tiktok_count . ', Instagram: ' . $instagram_count;
        $output .= '</li>';
    }
    
    $output .= '</ul>';
    
    return $output;
}

// ショートコードを登録
add_shortcode('RM-check_videos', 'ryoumou_trade_check_videos');  // 関数名を変更
?>
