<?php
function rm_custom_sitemap_shortcode() {
    ob_start();
    ?>
    <div class="container">

        <?php
        // 全ての親カテゴリを取得
        $categories = get_categories(array('hide_empty' => 1, 'parent' => 0));
        foreach ($categories as $category) {
            // 子カテゴリを取得
            $child_categories = get_categories(array('child_of' => $category->term_id, 'hide_empty' => 1));
            $exclude_posts = array();
            $has_posts = false;

            // 子カテゴリに属する全ての投稿を取得
            foreach ($child_categories as $child_category) {
                $args = array(
                    'category' => $child_category->term_id,
                    'post_status' => 'publish',
                    'posts_per_page' => -1, // 全ての投稿を表示
                    'orderby' => 'title',
                    'order' => 'ASC',
                );
                $posts = get_posts($args);
                if ($posts) {
                    $has_posts = true;
                    break;
                }
            }

            if ($has_posts) {
                echo '<h2><a href="' . get_category_link($category->term_id) . '">' . $category->name . '</a></h2>';

                foreach ($child_categories as $child_category) {
                    $args = array(
                        'category' => $child_category->term_id,
                        'post_status' => 'publish',
                        'posts_per_page' => -1, // 全ての投稿を表示
                        'orderby' => 'title',
                        'order' => 'ASC',
                    );
                    $posts = get_posts($args);
                    if ($posts) {
                        echo '<h3><a href="' . get_category_link($child_category->term_id) . '">' . $child_category->name . '</a></h3>';
                        echo '<ul>';
                        foreach ($posts as $post) {
                            setup_postdata($post);
                            $exclude_posts[] = $post->ID;
                            echo '<li><a href="' . get_permalink($post->ID) . '">' . get_the_title($post->ID) . '</a></li>';
                        }
                        echo '</ul>';
                        wp_reset_postdata();
                    }
                }

                // 親カテゴリに属するが、子カテゴリに属していない投稿を取得
                $args = array(
                    'category' => $category->term_id,
                    'post_status' => 'publish',
                    'posts_per_page' => -1, // 全ての投稿を表示
                    'post__not_in' => $exclude_posts, // 子カテゴリに属する投稿を除外
                    'orderby' => 'title',
                    'order' => 'ASC',
                );
                $posts = get_posts($args);
                if ($posts) {
                    echo '<ul>';
                    foreach ($posts as $post) {
                        setup_postdata($post);
                        echo '<li><a href="' . get_permalink($post->ID) . '">' . get_the_title($post->ID) . '</a></li>';
                    }
                    echo '</ul>';
                    wp_reset_postdata();
                }
            }
        }

        // 固定ページの一覧を表示
        $pages = get_pages(array(
            'sort_column' => 'post_title',
            'sort_order' => 'asc'
        ));
        if ($pages) {
            echo '<h2>固定ページ</h2>';
            echo '<ul>';
            foreach ($pages as $page) {
                echo '<li><a href="' . get_page_link($page->ID) . '">' . $page->post_title . '</a></li>';
            }
            echo '</ul>';
        }
        ?>

    </div>
    <?php
    return ob_get_clean();
}
add_shortcode('RM-custom_sitemap', 'rm_custom_sitemap_shortcode');
?>
