<?php
// デバッグ　画像alt未設定抽出　2024/8/21
function RM_images_without_alt_shortcode() {
    // ブログのホームURLを取得
    $blog_url = get_home_url();

    // 全ての投稿を取得
    $args = array(
        'post_type' => 'post',
        'posts_per_page' => -1,
    );
    $all_posts = get_posts($args);

    $output = '<ul>';

    // 各投稿をチェック
    foreach($all_posts as $post) {
        // 投稿の内容を取得
        $content = $post->post_content;

        // 画像タグを正規表現で抽出
        preg_match_all('/<img[^>]+>/i', $content, $images);

        // 画像タグをチェック
        foreach($images[0] as $image) {
            // 画像タグのsrc属性をチェック
            preg_match('/src=["\']([^"\']*)["\']/i', $image, $src);

            // 画像がブログ内のものかどうかをチェック
            if (isset($src[1]) && strpos($src[1], $blog_url) === false) {
                continue; // ブログ外の画像を除外
            }

            // alt属性をチェック
            preg_match('/alt=["\']([^"\']*)["\']/i', $image, $alt);

            // alt属性がないか空の場合のみリストに追加
            if (!isset($alt[1]) || empty($alt[1])) {
                $alt_text = 'alt属性なし';
                $post_title = get_the_title($post->ID);
                $post_link = get_permalink($post->ID);
                $output .= '<li>' . $image . ' - ALT: ' . $alt_text . ' (<a href="' . $post_link . '">' . $post_title . '</a>)</li>';
            }
        }
    }

    $output .= '</ul>';
    
    // 結果を返す
    return $output;
}

// ショートコードを作成する
add_shortcode('RM-images_without_alt', 'RM_images_without_alt_shortcode');
